/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPODEBITO                                               */
/* Tabela : TPDEBIBANC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 23/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPODEBITO' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPODEBITO
GO

CREATE TRIGGER DTULTATU_TIPODEBITO
ON TPDEBIBANC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TPDEBIBANC', null, 'CDTPDEBIBANC=' + CDTPDEBIBANC + ';',                                     GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TPDEBIBANC
      SET DTULTATUTPDB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TPDEBIBANC.CDTPDEBIBANC,0) = ISNULL(INSERTED.CDTPDEBIBANC,0)) AND                         (ISNULL(TPDEBIBANC.CDCLASSFINA,0 ) = ISNULL(INSERTED.CDCLASSFINA,0 )) AND
            (ISNULL(TPDEBIBANC.CDHISTPADR,0  ) = ISNULL(INSERTED.CDHISTPADR,0  )) AND
            (ISNULL(TPDEBIBANC.CDCONTCTBL,0  ) = ISNULL(INSERTED.CDCONTCTBL,0  )) AND
            (ISNULL(TPDEBIBANC.DSTPDEBIBANC,0) = ISNULL(INSERTED.DSTPDEBIBANC,0)) AND
            (ISNULL(TPDEBIBANC.IDCTBLDBBANC,0) = ISNULL(INSERTED.IDCTBLDBBANC,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPODEBITO','4.11.072';
GO

