IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'ATUALIZA_SALDO_CONS_FKB' AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

   DROP PROCEDURE ATUALIZA_SALDO_CONS_FKB
   GO

CREATE PROCEDURE ATUALIZA_SALDO_CONS_FKB
  @P_CDCLIENTE    VARCHAR(21),
  @P_CDCONSUMIDOR VARCHAR(21),
  @P_CDFAMILISALD VARCHAR(03),
  @P_DTINIEVOLUCAO  DATETIME
 AS

  DECLARE @V_CDCLIENTE     VARCHAR(21);
  DECLARE @V_MENORIGUAL    FLOAT;
  DECLARE @V_MAIORIGUAL    FLOAT;
  DECLARE @V_REGMENORIGUAL FLOAT;
  DECLARE @V_COUNTSALDO    FLOAT;
  DECLARE @V_DTLANCAMENTO  DATETIME;
  DECLARE @V_UCONSUMIDOR   VARCHAR(1);
  DECLARE @V_DTMOVEXTCONS  DATETIME;
  DECLARE @V_DTMOVANTE     DATETIME;
  DECLARE @V_VRMOVEXTCONS  FLOAT;
  DECLARE @V_IDTPMOVEXT    VARCHAR(1);
  DECLARE @V_VRSALDCONEXT  FLOAT;
  DECLARE @V_VRATUALPECONS FLOAT;
  DECLARE @V_NRSEQMOVEXT   VARCHAR(3);
  DECLARE @V_SALDOCONS     FLOAT;

  DECLARE @C_DTMOVEXTCONS DATETIME;
  DECLARE @C_VRMOVEXTCONS FLOAT;
  DECLARE @C_IDTPMOVEXT   VARCHAR(1);
  DECLARE @C_VRSALDCONEXT FLOAT;
  DECLARE @C_NRSEQMOVEXT  VARCHAR(3);

BEGIN

   /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
   SELECT
      @V_DTLANCAMENTO = MIN(DTMOVEXTCONS)
   FROM
      EXTRATOCONS
   WHERE
      (CDCLIENTE       = @P_CDCLIENTE   ) AND
      (CDFAMILISALD    = @P_CDFAMILISALD) AND
      (CDCONSUMIDOR    = @P_CDCONSUMIDOR) AND
      (DTMOVEXTCONS   >= @P_DTINIEVOLUCAO);

   SELECT TOP 1
      @V_VRATUALPECONS = VRSALDCONEXT,
      @V_NRSEQMOVEXT  = NRSEQMOVEXT
   FROM
      EXTRATOCONS
   WHERE
      (CDCLIENTE      = @P_CDCLIENTE   ) AND
      (CDFAMILISALD   = @P_CDFAMILISALD) AND
      (CDCONSUMIDOR   = @P_CDCONSUMIDOR) AND
      (DTMOVEXTCONS   = @V_DTLANCAMENTO)
   ORDER BY
      DTMOVEXTCONS,NRSEQMOVEXT;

   /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
   SELECT
      @V_MAIORIGUAL = COUNT(DTMOVEXTCONS)
   FROM
      EXTRATOCONS
   WHERE
      (CDCLIENTE     = @P_CDCLIENTE   ) AND
      (CDFAMILISALD  = @P_CDFAMILISALD) AND
      (CDCONSUMIDOR  = @P_CDCONSUMIDOR) AND
      (DTMOVEXTCONS >= @V_DTLANCAMENTO   );
   /*Atualiza lanamentos posteriores*/
   IF @V_MAIORIGUAL > 1 BEGIN
      SET @V_DTMOVANTE = GETDATE();

      DECLARE CUR_EXTRATOCONS CURSOR FOR
         SELECT
            DTMOVEXTCONS,VRMOVEXTCONS,IDTPMOVEXT,VRSALDCONEXT, NRSEQMOVEXT
         FROM
            EXTRATOCONS
         WHERE
            (CDCLIENTE     = @P_CDCLIENTE   ) AND
            (CDFAMILISALD  = @P_CDFAMILISALD) AND
            (CDCONSUMIDOR  = @P_CDCONSUMIDOR) AND
            ((DTMOVEXTCONS > @V_DTLANCAMENTO) OR ((DTMOVEXTCONS = @V_DTLANCAMENTO) AND (NRSEQMOVEXT <> @V_NRSEQMOVEXT )))
         ORDER BY
            DTMOVEXTCONS,NRSEQMOVEXT
      OPEN CUR_EXTRATOCONS;
      FETCH NEXT FROM CUR_EXTRATOCONS INTO @C_DTMOVEXTCONS,@C_VRMOVEXTCONS,@C_IDTPMOVEXT,@C_VRSALDCONEXT, @C_NRSEQMOVEXT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_VRMOVEXTCONS = @C_VRMOVEXTCONS;

         IF @C_IDTPMOVEXT = 'V' BEGIN
            SET @V_VRMOVEXTCONS = (-1) * @C_VRMOVEXTCONS;
         END ELSE IF @C_IDTPMOVEXT = 'D' BEGIN
            SET @V_VRMOVEXTCONS = (-1) * @C_VRMOVEXTCONS;
		 END ELSE IF @C_IDTPMOVEXT = 'E' BEGIN
            SET @V_VRMOVEXTCONS = (-1) * @C_VRMOVEXTCONS;
         END;

         SET @V_VRATUALPECONS = @V_VRATUALPECONS + @V_VRMOVEXTCONS;

         /*Atualiza os lanamentos*/
         UPDATE
            EXTRATOCONS
         SET
            VRSALDCONEXT = @V_VRATUALPECONS
         WHERE
            (CDCLIENTE      = @P_CDCLIENTE   ) AND
            (CDFAMILISALD   = @P_CDFAMILISALD) AND
            (CDCONSUMIDOR   = @P_CDCONSUMIDOR) AND
            (NRSEQMOVEXT    = @C_NRSEQMOVEXT)  AND
            (DTMOVEXTCONS   = @C_DTMOVEXTCONS);

         SELECT @V_SALDOCONS = COUNT(CDCLIENTE)
           FROM SALDOCONS
          WHERE CDCLIENTE = @P_CDCLIENTE
            AND CDCONSUMIDOR = @P_CDCONSUMIDOR
            AND CDFAMILISALD = @P_CDFAMILISALD;

         IF @V_SALDOCONS >= 1 BEGIN
            UPDATE SALDOCONS
               SET VRSALDCONFAM = @V_VRATUALPECONS
             WHERE CDCLIENTE = @P_CDCLIENTE
               AND CDFAMILISALD = @P_CDFAMILISALD
               AND CDCONSUMIDOR = @P_CDCONSUMIDOR;
         END ELSE BEGIN
            INSERT INTO SALDOCONS
                   (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM)
            VALUES (@P_CDCLIENTE, @P_CDCONSUMIDOR, @P_CDFAMILISALD, @V_VRATUALPECONS);
         END;

         SET @V_DTMOVANTE = @C_DTMOVEXTCONS;

         FETCH NEXT FROM CUR_EXTRATOCONS INTO @C_DTMOVEXTCONS,@C_VRMOVEXTCONS,@C_IDTPMOVEXT,@C_VRSALDCONEXT,@C_NRSEQMOVEXT;
      END;
      CLOSE CUR_EXTRATOCONS;
      DEALLOCATE CUR_EXTRATOCONS;
   END;

   IF @V_MAIORIGUAL = 1 BEGIN

      SELECT @V_IDTPMOVEXT = IDTPMOVEXT,
             @V_VRMOVEXTCONS = VRMOVEXTCONS
        FROM EXTRATOCONS
       WHERE CDCLIENTE = @P_CDCLIENTE
         AND CDCONSUMIDOR = @P_CDCONSUMIDOR
         AND CDFAMILISALD = @P_CDFAMILISALD;

      IF @V_IDTPMOVEXT = 'V' BEGIN
         SET @V_VRMOVEXTCONS = (-1) * @V_VRMOVEXTCONS;
      END ELSE IF @V_IDTPMOVEXT = 'D' BEGIN
         SET @V_VRMOVEXTCONS = (-1) * @V_VRMOVEXTCONS;
	  END ELSE IF @V_IDTPMOVEXT = 'E' BEGIN
         SET @V_VRMOVEXTCONS = (-1) * @V_VRMOVEXTCONS;
      END;

      UPDATE EXTRATOCONS
         SET VRSALDCONEXT = @V_VRMOVEXTCONS
       WHERE CDCLIENTE = @P_CDCLIENTE
         AND CDCONSUMIDOR = @P_CDCONSUMIDOR
         AND CDFAMILISALD = @P_CDFAMILISALD;

      SELECT @V_SALDOCONS = COUNT(CDCLIENTE)
        FROM SALDOCONS
       WHERE CDCLIENTE = @P_CDCLIENTE
         AND CDCONSUMIDOR = @P_CDCONSUMIDOR
         AND CDFAMILISALD = @P_CDFAMILISALD;

      IF @V_SALDOCONS >= 1 BEGIN
         UPDATE SALDOCONS
            SET VRSALDCONFAM = @V_VRMOVEXTCONS
          WHERE CDCLIENTE = @P_CDCLIENTE
            AND CDFAMILISALD = @P_CDFAMILISALD
            AND CDCONSUMIDOR = @P_CDCONSUMIDOR;
      END ELSE BEGIN
         INSERT INTO SALDOCONS
                (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM)
         VALUES (@P_CDCLIENTE, @P_CDCONSUMIDOR, @P_CDFAMILISALD, @V_VRMOVEXTCONS);
      END;
   END;
END;

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_SALDO_CONS_FKB','5.02.040';
GO
